4 cd "$(readlink -f $(dirname $0))"
6 if [ -n "${GBP_BUILD_DIR}" ]; then
10 VERSION
=$(dpkg-parsechangelog | sed -n -e '/^Version:/s/^Version: //p')
11 DISTRIBUTION
=$(dpkg-parsechangelog | sed -n -e '/^Distribution:/s/^Distribution: //p')
13 LIBAPTPKGVERSION
="$(awk -v ORS='.' '/^\#define APT_PKG_M/ {print $3}' apt-pkg/contrib/macros.h | sed 's/\.$//')"
14 LIBAPTINSTVERSION
="$(sed -nr 's/set\(MAJOR ([^)]*)\)/\1/p' apt-inst/CMakeLists.txt)"
16 librarysymbolsfromfile
() {
17 local MISSING
="$(grep '^+#MISSING' "$1")"
19 echo '=== Missing optional symbols:'
20 echo -n "$MISSING" | grep '|optional=' || true
21 echo '=== Missing required symbols:'
22 echo -n "$MISSING" | grep -v '|optional=' || true
23 echo '=== New symbols:'
24 grep '^+ ' "$1" | grep -v '^+ (c++' | cut
-d' ' -f 2 | cut
-d'@' -f 1 | c
++filt
| while read line
; do
25 echo " (c++)\"${line}@${SYMVER}\" $VERSION"
29 if [ "$1" = 'pre-export' ]; then
30 libraryversioncheck
() {
33 if [ ! -e "debian/${LIBRARY}${VERSION}.symbols" ]; then
34 echo >&2 "Library ${LIBRARY} in version ${VERSION} has no symbols file! (maybe forgot to rename?)"
37 if [ "$(head -n1 "debian/${LIBRARY}${VERSION}.symbols")" != "${LIBRARY}.so.${VERSION} ${LIBRARY}${VERSION} #MINVER#" ]; then
38 echo >&2 "Library ${LIBRARY}${VERSION} has incorrect version in symbol header! (»$(head -n1 "debian/${LIBRARY}${VERSION}.symbols")«)"
43 libraryversioncheck
'libapt-pkg' "$LIBAPTPKGVERSION"
44 libraryversioncheck
'libapt-inst' "$LIBAPTINSTVERSION"
47 if [ "$DISTRIBUTION" = 'sid' ]; then
48 echo >&2 '»sid« is not a valid distribution. Replace it with »unstable« for you'
49 sed -i -e 's/) sid; urgency=/) unstable; urgency=/' debian
/changelog
50 DISTRIBUTION
='unstable'
51 elif [ "$DISTRIBUTION" = 'UNRELEASED' ]; then
52 echo >&2 'WARNING: Remember to change to a valid distribution for release'
53 VERSION
="$VERSION~$(date +%Y%m%d)"
56 sed -i -e "s/^set(PACKAGE_VERSION \".*\")$/set(PACKAGE_VERSION \"${VERSION}\")/" CMakeLists.txt
57 sed -i -e "s/^<!ENTITY apt-product-version \".*\">$/<!ENTITY apt-product-version \"${VERSION}\">/" doc
/apt
-verbatim.ent
59 # update the last-modification field of manpages based on git changes
60 grep --files-with-matches '<date>' doc
/*.xml
| while read file; do \
61 LASTMOD
="$(date -d "@$
(git log
--format='%at' --max-count=1 --invert-grep --fixed-strings --grep 'review
64 Git-Dch: Ignore' "$file")" '+%Y-%m-%dT00:00:00Z')"
65 sed -i -e "s#^\([ ]\+\)<date>.*</date>\$#\1<date>$LASTMOD</date>#" "$file"
68 if [ "$(date +%Y-%m-%d)" != "$(grep --max-count=1 '^"POT-Creation-Date: .*\n"$' po/apt-all.pot | cut -d' ' -f 2)" -o \
69 "$(date +%Y-%m-%d)" != "$(grep --max-count=1 '^"POT-Creation-Date: .*\n"$' doc/po/apt-doc.pot | cut -d' ' -f 2)" ]; then
70 echo >&2 'POT files are not up-to-date. Execute »make update-po« for you…'
71 [ -e build
] || mkdir build
72 ( cd build
&& cmake ..
)
73 cmake
--build build
--target update
-po -- -j 4
75 elif [ "$1" = 'pre-build' ]; then
76 if [ "$DISTRIBUTION" = "UNRELEASED" ]; then
77 echo 'BUILDING AN UNRELEASED VERSION'
79 CONFVERSION
="$(sed -ne "s/^set(PACKAGE_VERSION \"\(.*\)\")$/\1/p" CMakeLists.txt
)"
80 if [ "$VERSION" != "$CONFVERSION" ]; then
81 echo "changelog
(${VERSION}) and CMakeLists.txt
(${CONFVERSION}) talk about different versions
!"
82 echo "You probably want to run ».
/prepare
-release pre
-export« to fix this.
"
86 elif [ "$1" = 'post-build' ]; then
87 if [ "$DISTRIBUTION" != "UNRELEASED
" ]; then
88 echo >&2 "REMEMBER
: Tag this release with »git tag
-s ${VERSION}«
if you are satisfied
"
90 echo >&2 'REMEMBER: Change to a valid distribution before release'
93 dpkg-checkbuilddeps -d 'libxml2-utils'
95 HEADERBLUEPRINT="$(mktemp)"
96 sed -n '1,/^$/p' doc/apt.8.xml > "$HEADERBLUEPRINT"
97 find doc -mindepth 1 -maxdepth 1 -type f -name '*.xml' | while read FILE; do
98 if ! sed -n '1,/^$/p' "$FILE" | cmp "$HEADERBLUEPRINT" - >/dev/null 2>&1; then
99 echo >&2 "WARNING
: Manpage
$FILE has not the usual header
! (see
diff below
)"
100 sed -n '1,/^$/p' "$FILE" | diff -u "$HEADERBLUEPRINT" - || true
103 sed -n '1,/^$/p' doc/guide.dbk > "$HEADERBLUEPRINT"
104 find doc -mindepth 1 -maxdepth 1 -type f -name '*.dbk' | while read FILE; do
105 if ! sed -n '1,/^$/p' "$FILE" | cmp "$HEADERBLUEPRINT" - >/dev/null 2>&1; then
106 echo >&2 "WARNING
: Documentation
$FILE has not the usual header
(see
diff below
)!"
107 sed -n '1,/^$/p' "$FILE" | diff -u "$HEADERBLUEPRINT" - || true
110 rm "$HEADERBLUEPRINT"
112 # check the manpages with each vendor for vendor-specific errors…
113 find vendor -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 2 | while read DISTRO; do
114 ln -sf ../vendor/${DISTRO}/apt-vendor.ent doc
115 if ! xmllint --nonet --valid --noout $(find doc/ -maxdepth 1 -name '*.xml'); then
116 echo >&2 "WARNING
: original docbook manpages have errors with vendor
${DISTRO}!"
119 # lets assume we will always have a german manpage translation
120 if [ -e */doc/de/ -o -e doc/de ]; then
121 # … but check the translations only with one vendor for translation-specific errors
122 if ! xmllint --path /vendor/$(./vendor/getinfo current)/ \
124 --nonet --valid --noout $(find doc/ */doc/ -mindepth 2 -maxdepth 2 -name '*.xml'); then
125 echo >&2 "WARNING
: translated docbook manpages have errors
!"
128 echo >&2 "ERROR
: translated manpages need to be build before they can be checked
!"
130 rm -f doc/apt-vendor.ent
132 elif [ "$1" = 'library' ]; then
134 local libname=$(echo "${1}" | cut -c 4-)
135 local buildlib="build
/bin
/${1}.so.
${2}"
136 for dir in $libname */$libname; do
137 local new_buildlib="$dir/${1}.so.
${2}"
138 if [ -r "${new_buildlib}" ] && [ ! -e "$buildlib" -o "$new_buildlib" -nt "$buildlib" ]; then
139 local buildlib="${new_buildlib}"
142 if [ ! -r "$buildlib" ]; then
143 echo "ERROR
: The library
${1} has to be built before symbols can be checked
!"
146 echo "Checking
$1 in version
$2 build
at $(stat -L -c '%y' "$buildlib")"
147 local tmpfile=$(mktemp)
148 dpkg-gensymbols -p${1}${2} -e${buildlib} -Idebian/${1}${2}.symbols -O/dev/null 2> /dev/null > $tmpfile || true
149 librarysymbolsfromfile "$tmpfile" "$(echo "${1}" | cut -c 4- | tr -d '-' | tr 'a-z' 'A-Z')_
${2}"
152 librarysymbols 'libapt-pkg' "${LIBAPTPKGVERSION}"
154 librarysymbols 'libapt-inst' "${LIBAPTINSTVERSION}"
155 elif [ "$1" = 'buildlog' ]; then
156 while [ -n "$2" ]; do
157 librarysymbolsfromfile "$2" 'UNKNOWN'
160 elif [ "$1" = 'travis-ci' ]; then
161 apt-get install -qy --no-install-recommends $(sed -n -e '/^Build-Depends: /,/^Build-Depends-Indep: / {p}' debian/control | sed -e 's#([^)]*)##g' -e 's#^Build-Depends\(-Indep\)\?: ##' -e 's#<.*>##g' | tr -d ',')
162 apt-get install -qy --no-install-recommends $(sed -n 's#^Depends: .*@, \(.*\)$#\1#p' debian/tests/control | tr -d ',')
163 elif [ "$1" = 'coverage' ]; then
164 DIR="${2:-./coverage}"
165 git clean -dfX # remove ignored build artefacts for a clean start
166 make CFLAGS+='--coverage' CXXFLAGS+='--coverage'
167 LCOVRC='--rc geninfo_checksum=1 --rc lcov_branch_coverage=1'
169 lcov --no-external --directory . --capture --initial --output-file "${DIR}/apt.coverage.init
" ${LCOVRC}
171 ./test/integration/run-tests -q || true
172 lcov --no-external --directory . --capture --output-file "${DIR}/apt.coverage.run
" ${LCOVRC}
173 lcov -a "${DIR}/apt.coverage.init
" -a "${DIR}/apt.coverage.run
" -o "${DIR}/apt.coverage.total
" ${LCOVRC}
174 cp "${DIR}/apt.coverage.total
" "${DIR}/apt.coverage.fixed
"
178 name="$(basename "$file")"
179 while [ -n "$1" ]; do
180 if [ -r "$1/$name" ]; then
181 sed -i "s
#$file#$1/$name#" "${DIR}/apt.coverage.fixed"
187 echo >&2 "Coverage data captured for unknown file $file"
190 grep 'build/include/' "${DIR}/apt.coverage.fixed" | sed "s#^SF:$(pwd)/##" | while read file; do
191 rewritefile
"$file" 'apt-pkg' 'apt-pkg/deb' 'apt-pkg/edsp' 'apt-pkg/contrib' \
192 'apt-inst' 'apt-inst/deb' 'apt-inst/contrib' 'apt-private'
194 genhtml
--output-directory "${DIR}" "${DIR}/apt.coverage.fixed" ${LCOVRC}
196 echo >&1 "Usage:\t$0 pre-export
200 Updating po-files and versions as well as some basic checks are done
201 by »pre-export« which needs to be run before package building.
202 If you use »gbp buildpackage« you will be notified if you forget.
203 »pre-build« and »post-build« can be used to run some more or less
204 useful checks automatically run by »gbp« otherwise.
207 \t$0 buildlog filename…
209 »library« and »buildlog« aren't run automatically but can be useful for
210 maintaining the (more or less experimental) symbols files we provide.
211 »library« displays the diff between advertised symbols and the once provided
212 by the libraries, while »buildlog« extracts this diff from the buildlogs.
213 Both will format the diff properly.
216 \t$0 coverage [output-dir]
218 »travis-ci« is a shortcut to install all build- as well as test-dependencies
220 »coverage« does a clean build with the right flags for coverage reporting,
221 runs all tests and generates a html report in the end.